maint.mk: avoid redundant file name in message
[gnulib.git] / top / maint.mk
1 # -*-Makefile-*-
2 # This Makefile fragment tries to be general-purpose enough to be
3 # used by many projects via the gnulib maintainer-makefile module.
4
5 ## Copyright (C) 2001-2012 Free Software Foundation, Inc.
6 ##
7 ## This program is free software: you can redistribute it and/or modify
8 ## it under the terms of the GNU General Public License as published by
9 ## the Free Software Foundation, either version 3 of the License, or
10 ## (at your option) any later version.
11 ##
12 ## This program is distributed in the hope that it will be useful,
13 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
14 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
15 ## GNU General Public License for more details.
16 ##
17 ## You should have received a copy of the GNU General Public License
18 ## along with this program.  If not, see <http://www.gnu.org/licenses/>.
19
20 # This is reported not to work with make-3.79.1
21 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
22 ME := maint.mk
23
24 # Diagnostic for continued use of deprecated variable.
25 # Remove in 2013
26 ifneq ($(build_aux),)
27  $(error "$(ME): \
28 set $$(_build-aux) relative to $$(srcdir) instead of $$(build_aux)")
29 endif
30
31 # Do not save the original name or timestamp in the .tar.gz file.
32 # Use --rsyncable if available.
33 gzip_rsyncable := \
34   $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null \
35     && printf %s --rsyncable)
36 GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
37
38 GIT = git
39 VC = $(GIT)
40
41 VC_LIST = $(srcdir)/$(_build-aux)/vc-list-files -C $(srcdir)
42
43 # You can override this variable in cfg.mk to set your own regexp
44 # matching files to ignore.
45 VC_LIST_ALWAYS_EXCLUDE_REGEX ?= ^$$
46
47 # This is to preprocess robustly the output of $(VC_LIST), so that even
48 # when $(srcdir) is a pathological name like "....", the leading sed command
49 # removes only the intended prefix.
50 _dot_escaped_srcdir = $(subst .,\.,$(srcdir))
51
52 # Post-process $(VC_LIST) output, prepending $(srcdir)/, but only
53 # when $(srcdir) is not ".".
54 ifeq ($(srcdir),.)
55 _prepend_srcdir_prefix =
56 else
57 _prepend_srcdir_prefix = | sed 's|^|$(srcdir)/|'
58 endif
59
60 # In order to be able to consistently filter "."-relative names,
61 # (i.e., with no $(srcdir) prefix), this definition is careful to
62 # remove any $(srcdir) prefix, and to restore what it removes.
63 _sc_excl = \
64   $(or $(exclude_file_name_regexp--$@),^$$)
65 VC_LIST_EXCEPT = \
66   $(VC_LIST) | sed 's|^$(_dot_escaped_srcdir)/||' \
67         | if test -f $(srcdir)/.x-$@; then grep -vEf $(srcdir)/.x-$@; \
68           else grep -Ev -e "$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \
69         | grep -Ev -e '($(VC_LIST_ALWAYS_EXCLUDE_REGEX)|$(_sc_excl))' \
70         $(_prepend_srcdir_prefix)
71
72 ifeq ($(origin prev_version_file), undefined)
73   prev_version_file = $(srcdir)/.prev-version
74 endif
75
76 PREV_VERSION := $(shell cat $(prev_version_file) 2>/dev/null)
77 VERSION_REGEXP = $(subst .,\.,$(VERSION))
78 PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
79
80 ifeq ($(VC),$(GIT))
81 this-vc-tag = v$(VERSION)
82 this-vc-tag-regexp = v$(VERSION_REGEXP)
83 else
84 tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
85 tag-this-version = $(subst .,_,$(VERSION))
86 this-vc-tag = $(tag-package)-$(tag-this-version)
87 this-vc-tag-regexp = $(this-vc-tag)
88 endif
89 my_distdir = $(PACKAGE)-$(VERSION)
90
91 # Old releases are stored here.
92 release_archive_dir ?= ../release
93
94 # Override gnu_rel_host and url_dir_list in cfg.mk if these are not right.
95 # Use alpha.gnu.org for alpha and beta releases.
96 # Use ftp.gnu.org for stable releases.
97 gnu_ftp_host-alpha = alpha.gnu.org
98 gnu_ftp_host-beta = alpha.gnu.org
99 gnu_ftp_host-stable = ftp.gnu.org
100 gnu_rel_host ?= $(gnu_ftp_host-$(RELEASE_TYPE))
101
102 ifeq ($(gnu_rel_host),ftp.gnu.org)
103 url_dir_list ?= http://ftpmirror.gnu.org/$(PACKAGE)
104 else
105 url_dir_list ?= ftp://$(gnu_rel_host)/gnu/$(PACKAGE)
106 endif
107
108 # Override this in cfg.mk if you are using a different format in your
109 # NEWS file.
110 today = $(shell date +%Y-%m-%d)
111
112 # Select which lines of NEWS are searched for $(news-check-regexp).
113 # This is a sed line number spec.  The default says that we search
114 # lines 1..10 of NEWS for $(news-check-regexp).
115 # If you want to search only line 3 or only lines 20-22, use "3" or "20,22".
116 news-check-lines-spec ?= 1,10
117 news-check-regexp ?= '^\*.* $(VERSION_REGEXP) \($(today)\)'
118
119 # Prevent programs like 'sort' from considering distinct strings to be equal.
120 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
121 export LC_ALL = C
122
123 ## --------------- ##
124 ## Sanity checks.  ##
125 ## --------------- ##
126
127 _cfg_mk := $(shell test -f $(srcdir)/cfg.mk && echo '$(srcdir)/cfg.mk')
128
129 # Collect the names of rules starting with 'sc_'.
130 syntax-check-rules := $(sort $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
131                         $(srcdir)/$(ME) $(_cfg_mk)))
132 .PHONY: $(syntax-check-rules)
133
134 ifeq ($(shell $(VC_LIST) >/dev/null 2>&1; echo $$?),0)
135 local-checks-available += $(syntax-check-rules)
136 else
137 local-checks-available += no-vc-detected
138 no-vc-detected:
139         @echo "No version control files detected; skipping syntax check"
140 endif
141 .PHONY: $(local-checks-available)
142
143 # Arrange to print the name of each syntax-checking rule just before running it.
144 $(syntax-check-rules): %: %.m
145 sc_m_rules_ = $(patsubst %, %.m, $(syntax-check-rules))
146 .PHONY: $(sc_m_rules_)
147 $(sc_m_rules_):
148         @echo $(patsubst sc_%.m, %, $@)
149         @date +%s.%N > .sc-start-$(basename $@)
150
151 # Compute and print the elapsed time for each syntax-check rule.
152 sc_z_rules_ = $(patsubst %, %.z, $(syntax-check-rules))
153 .PHONY: $(sc_z_rules_)
154 $(sc_z_rules_): %.z: %
155         @end=$$(date +%s.%N);                                           \
156         start=$$(cat .sc-start-$*);                                     \
157         rm -f .sc-start-$*;                                             \
158         awk -v s=$$start -v e=$$end                                     \
159           'END {printf "%.2f $(patsubst sc_%,%,$*)\n", e - s}' < /dev/null
160
161 # The patsubst here is to replace each sc_% rule with its sc_%.z wrapper
162 # that computes and prints elapsed time.
163 local-check :=                                                          \
164   $(patsubst sc_%, sc_%.z,                                              \
165     $(filter-out $(local-checks-to-skip), $(local-checks-available)))
166
167 syntax-check: $(local-check)
168
169 # _sc_search_regexp
170 #
171 # This macro searches for a given construct in the selected files and
172 # then takes some action.
173 #
174 # Parameters (shell variables):
175 #
176 #  prohibit | require
177 #
178 #     Regular expression (ERE) denoting either a forbidden construct
179 #     or a required construct.  Those arguments are exclusive.
180 #
181 #  exclude
182 #
183 #     Regular expression (ERE) denoting lines to ignore that matched
184 #     a prohibit construct.  For example, this can be used to exclude
185 #     comments that mention why the nearby code uses an alternative
186 #     construct instead of the simpler prohibited construct.
187 #
188 #  in_vc_files | in_files
189 #
190 #     grep-E-style regexp selecting the files to check.  For in_vc_files,
191 #     the regexp is used to select matching files from the list of all
192 #     version-controlled files; for in_files, it's from the names printed
193 #     by "find $(srcdir)".  When neither is specified, use all files that
194 #     are under version control.
195 #
196 #  containing | non_containing
197 #
198 #     Select the files (non) containing strings matching this regexp.
199 #     If both arguments are specified then CONTAINING takes
200 #     precedence.
201 #
202 #  with_grep_options
203 #
204 #     Extra options for grep.
205 #
206 #  ignore_case
207 #
208 #     Ignore case.
209 #
210 #  halt
211 #
212 #     Message to display before to halting execution.
213 #
214 # Finally, you may exempt files based on an ERE matching file names.
215 # For example, to exempt from the sc_space_tab check all files with the
216 # .diff suffix, set this Make variable:
217 #
218 # exclude_file_name_regexp--sc_space_tab = \.diff$
219 #
220 # Note that while this functionality is mostly inherited via VC_LIST_EXCEPT,
221 # when filtering by name via in_files, we explicitly filter out matching
222 # names here as well.
223
224 # Initialize each, so that envvar settings cannot interfere.
225 export require =
226 export prohibit =
227 export exclude =
228 export in_vc_files =
229 export in_files =
230 export containing =
231 export non_containing =
232 export halt =
233 export with_grep_options =
234
235 # By default, _sc_search_regexp does not ignore case.
236 export ignore_case =
237 _ignore_case = $$(test -n "$$ignore_case" && printf %s -i || :)
238
239 define _sc_say_and_exit
240    dummy=; : so we do not need a semicolon before each use;             \
241    { printf '%s\n' "$(ME): $$msg" 1>&2; exit 1; };
242 endef
243
244 define _sc_search_regexp
245    dummy=; : so we do not need a semicolon before each use;             \
246                                                                         \
247    : Check arguments;                                                   \
248    test -n "$$prohibit" && test -n "$$require"                          \
249      && { msg='Cannot specify both prohibit and require'                \
250           $(_sc_say_and_exit) } || :;                                   \
251    test -z "$$prohibit" && test -z "$$require"                          \
252      && { msg='Should specify either prohibit or require'               \
253           $(_sc_say_and_exit) } || :;                                   \
254    test -z "$$prohibit" && test -n "$$exclude"                          \
255      && { msg='Use of exclude requires a prohibit pattern'              \
256           $(_sc_say_and_exit) } || :;                                   \
257    test -n "$$in_vc_files" && test -n "$$in_files"                      \
258      && { msg='Cannot specify both in_vc_files and in_files'            \
259           $(_sc_say_and_exit) } || :;                                   \
260    test "x$$halt" != x                                                  \
261      || { msg='halt not defined' $(_sc_say_and_exit) };                 \
262                                                                         \
263    : Filter by file name;                                               \
264    if test -n "$$in_files"; then                                        \
265      files=$$(find $(srcdir) | grep -E "$$in_files"                     \
266               | grep -Ev '$(_sc_excl)');                                \
267    else                                                                 \
268      files=$$($(VC_LIST_EXCEPT));                                       \
269      if test -n "$$in_vc_files"; then                                   \
270        files=$$(echo "$$files" | grep -E "$$in_vc_files");              \
271      fi;                                                                \
272    fi;                                                                  \
273                                                                         \
274    : Filter by content;                                                 \
275    test -n "$$files" && test -n "$$containing"                          \
276      && { files=$$(grep -l "$$containing" $$files); } || :;             \
277    test -n "$$files" && test -n "$$non_containing"                      \
278      && { files=$$(grep -vl "$$non_containing" $$files); } || :;        \
279                                                                         \
280    : Check for the construct;                                           \
281    if test -n "$$files"; then                                           \
282      if test -n "$$prohibit"; then                                      \
283        grep $$with_grep_options $(_ignore_case) -nE "$$prohibit" $$files \
284          | grep -vE "$${exclude:-^$$}"                                  \
285          && { msg="$$halt" $(_sc_say_and_exit) } || :;                  \
286      else                                                               \
287        grep $$with_grep_options $(_ignore_case) -LE "$$require" $$files \
288            | grep .                                                     \
289          && { msg="$$halt" $(_sc_say_and_exit) } || :;                  \
290      fi                                                                 \
291    else :;                                                              \
292    fi || :;
293 endef
294
295 sc_avoid_if_before_free:
296         @$(srcdir)/$(_build-aux)/useless-if-before-free                 \
297                 $(useless_free_options)                                 \
298             $$($(VC_LIST_EXCEPT) | grep -v useless-if-before-free) &&   \
299           { echo '$(ME): found useless "if" before "free" above' 1>&2;  \
300             exit 1; } || :
301
302 sc_cast_of_argument_to_free:
303         @prohibit='\<free *\( *\(' halt="don't cast free argument"      \
304           $(_sc_search_regexp)
305
306 sc_cast_of_x_alloc_return_value:
307         @prohibit='\*\) *x(m|c|re)alloc\>'                              \
308         halt="don't cast x*alloc return value"                          \
309           $(_sc_search_regexp)
310
311 sc_cast_of_alloca_return_value:
312         @prohibit='\*\) *alloca\>'                                      \
313         halt="don't cast alloca return value"                           \
314           $(_sc_search_regexp)
315
316 sc_space_tab:
317         @prohibit='[ ]  '                                               \
318         halt='found SPACE-TAB sequence; remove the SPACE'               \
319           $(_sc_search_regexp)
320
321 # Don't use *scanf or the old ato* functions in "real" code.
322 # They provide no error checking mechanism.
323 # Instead, use strto* functions.
324 sc_prohibit_atoi_atof:
325         @prohibit='\<([fs]?scanf|ato([filq]|ll)) *\('                           \
326         halt='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q'   \
327           $(_sc_search_regexp)
328
329 # Use STREQ rather than comparing strcmp == 0, or != 0.
330 sp_ = strcmp *\(.+\)
331 sc_prohibit_strcmp:
332         @prohibit='! *strcmp *\(|\<$(sp_) *[!=]=|[!=]= *$(sp_)'         \
333         exclude=':# *define STRN?EQ\('                                  \
334         halt='replace strcmp calls above with STREQ/STRNEQ'             \
335           $(_sc_search_regexp)
336
337 # Really.  You don't want to use this function.
338 # It may fail to NUL-terminate the destination,
339 # and always NUL-pads out to the specified length.
340 sc_prohibit_strncpy:
341         @prohibit='\<strncpy *\('                                       \
342         halt='do not use strncpy, period'                               \
343           $(_sc_search_regexp)
344
345 # Pass EXIT_*, not number, to usage, exit, and error (when exiting)
346 # Convert all uses automatically, via these two commands:
347 # git grep -l '\<exit *(1)' \
348 #  | grep -vEf .x-sc_prohibit_magic_number_exit \
349 #  | xargs --no-run-if-empty \
350 #      perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/'
351 # git grep -l '\<exit *(0)' \
352 #  | grep -vEf .x-sc_prohibit_magic_number_exit \
353 #  | xargs --no-run-if-empty \
354 #      perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
355 sc_prohibit_magic_number_exit:
356         @prohibit='(^|[^.])\<(usage|exit|error) ?\(-?[0-9]+[,)]'        \
357         exclude='error ?\((0,|[^,]*)'                                   \
358         halt='use EXIT_* values rather than magic number'               \
359           $(_sc_search_regexp)
360
361 # Using EXIT_SUCCESS as the first argument to error is misleading,
362 # since when that parameter is 0, error does not exit.  Use '0' instead.
363 sc_error_exit_success:
364         @prohibit='error *\(EXIT_SUCCESS,'                              \
365         in_vc_files='\.[chly]$$'                                        \
366         halt='found error (EXIT_SUCCESS'                                \
367          $(_sc_search_regexp)
368
369 # "FATAL:" should be fully upper-cased in error messages
370 # "WARNING:" should be fully upper-cased, or fully lower-cased
371 sc_error_message_warn_fatal:
372         @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT))              \
373             | grep -E '"Warning|"Fatal|"fatal' &&                       \
374           { echo '$(ME): use FATAL, WARNING or warning' 1>&2;           \
375             exit 1; } || :
376
377 # Error messages should not start with a capital letter
378 sc_error_message_uppercase:
379         @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT))              \
380             | grep -E '"[A-Z]'                                          \
381             | grep -vE '"FATAL|"WARNING|"Java|"C#|PRIuMAX' &&           \
382           { echo '$(ME): found capitalized error message' 1>&2;         \
383             exit 1; } || :
384
385 # Error messages should not end with a period
386 sc_error_message_period:
387         @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT))              \
388             | grep -E '[^."]\."' &&                                     \
389           { echo '$(ME): found error message ending in period' 1>&2;    \
390             exit 1; } || :
391
392 sc_file_system:
393         @prohibit=file''system                                          \
394         ignore_case=1                                                   \
395         halt='found use of "file''system"; spell it "file system"'      \
396           $(_sc_search_regexp)
397
398 # Don't use cpp tests of this symbol.  All code assumes config.h is included.
399 sc_prohibit_have_config_h:
400         @prohibit='^# *if.*HAVE''_CONFIG_H'                             \
401         halt='found use of HAVE''_CONFIG_H; remove'                     \
402           $(_sc_search_regexp)
403
404 # Nearly all .c files must include <config.h>.  However, we also permit this
405 # via inclusion of a package-specific header, if cfg.mk specified one.
406 # config_h_header must be suitable for grep -E.
407 config_h_header ?= <config\.h>
408 sc_require_config_h:
409         @require='^# *include $(config_h_header)'                       \
410         in_vc_files='\.c$$'                                             \
411         halt='the above files do not include <config.h>'                \
412           $(_sc_search_regexp)
413
414 # You must include <config.h> before including any other header file.
415 # This can possibly be via a package-specific header, if given by cfg.mk.
416 sc_require_config_h_first:
417         @if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then       \
418           fail=0;                                                       \
419           for i in $$($(VC_LIST_EXCEPT) | grep '\.c$$'); do             \
420             grep '^# *include\>' $$i | sed 1q                           \
421                 | grep -E '^# *include $(config_h_header)' > /dev/null  \
422               || { echo $$i; fail=1; };                                 \
423           done;                                                         \
424           test $$fail = 1 &&                                            \
425             { echo '$(ME): the above files include some other header'   \
426                 'before <config.h>' 1>&2; exit 1; } || :;               \
427         else :;                                                         \
428         fi
429
430 sc_prohibit_HAVE_MBRTOWC:
431         @prohibit='\bHAVE_MBRTOWC\b'                                    \
432         halt="do not use $$prohibit; it is always defined"              \
433           $(_sc_search_regexp)
434
435 # To use this "command" macro, you must first define two shell variables:
436 # h: the header name, with no enclosing <> or ""
437 # re: a regular expression that matches IFF something provided by $h is used.
438 define _sc_header_without_use
439   dummy=; : so we do not need a semicolon before each use;              \
440   h_esc=`echo '[<"]'"$$h"'[">]'|sed 's/\./\\\\./g'`;                    \
441   if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then              \
442     files=$$(grep -l '^# *include '"$$h_esc"                            \
443              $$($(VC_LIST_EXCEPT) | grep '\.c$$')) &&                   \
444     grep -LE "$$re" $$files | grep . &&                                 \
445       { echo "$(ME): the above files include $$h but don't use it"      \
446         1>&2; exit 1; } || :;                                           \
447   else :;                                                               \
448   fi
449 endef
450
451 # Prohibit the inclusion of assert.h without an actual use of assert.
452 sc_prohibit_assert_without_use:
453         @h='assert.h' re='\<assert *\(' $(_sc_header_without_use)
454
455 # Prohibit the inclusion of close-stream.h without an actual use.
456 sc_prohibit_close_stream_without_use:
457         @h='close-stream.h' re='\<close_stream *\(' $(_sc_header_without_use)
458
459 # Prohibit the inclusion of getopt.h without an actual use.
460 sc_prohibit_getopt_without_use:
461         @h='getopt.h' re='\<getopt(_long)? *\(' $(_sc_header_without_use)
462
463 # Don't include quotearg.h unless you use one of its functions.
464 sc_prohibit_quotearg_without_use:
465         @h='quotearg.h' re='\<quotearg(_[^ ]+)? *\(' $(_sc_header_without_use)
466
467 # Don't include quote.h unless you use one of its functions.
468 sc_prohibit_quote_without_use:
469         @h='quote.h' re='\<quote((_n)? *\(|_quoting_options\>)' \
470           $(_sc_header_without_use)
471
472 # Don't include this header unless you use one of its functions.
473 sc_prohibit_long_options_without_use:
474         @h='long-options.h' re='\<parse_long_options *\(' \
475           $(_sc_header_without_use)
476
477 # Don't include this header unless you use one of its functions.
478 sc_prohibit_inttostr_without_use:
479         @h='inttostr.h' re='\<(off|[iu]max|uint)tostr *\(' \
480           $(_sc_header_without_use)
481
482 # Don't include this header unless you use one of its functions.
483 sc_prohibit_ignore_value_without_use:
484         @h='ignore-value.h' re='\<ignore_(value|ptr) *\(' \
485           $(_sc_header_without_use)
486
487 # Don't include this header unless you use one of its functions.
488 sc_prohibit_error_without_use:
489         @h='error.h' \
490         re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
491           $(_sc_header_without_use)
492
493 # Don't include xalloc.h unless you use one of its functions.
494 # Consider these symbols:
495 # perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__';
496 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/xalloc.h
497 # Divide into two sets on case, and filter each through this:
498 # | sort | perl -MRegexp::Assemble -le \
499 #  'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g'
500 # Note this was produced by the above:
501 # _xa1 = \
502 #x(((2n?)?re|c(har)?|n(re|m)|z)alloc|alloc_(oversized|die)|m(alloc|emdup)|strdup)
503 # But we can do better, in at least two ways:
504 # 1) take advantage of two "dup"-suffixed strings:
505 # x(((2n?)?re|c(har)?|n(re|m)|[mz])alloc|alloc_(oversized|die)|(mem|str)dup)
506 # 2) notice that "c(har)?|[mz]" is equivalent to the shorter and more readable
507 # "char|[cmz]"
508 # x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
509 _xa1 = x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
510 _xa2 = X([CZ]|N?M)ALLOC
511 sc_prohibit_xalloc_without_use:
512         @h='xalloc.h' \
513         re='\<($(_xa1)|$(_xa2)) *\('\
514           $(_sc_header_without_use)
515
516 # Extract function names:
517 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/hash.h
518 _hash_re = \
519 clear|delete|free|get_(first|next)|insert|lookup|print_statistics|reset_tuning
520 _hash_fn = \<($(_hash_re)) *\(
521 _hash_struct = (struct )?\<[Hh]ash_(table|tuning)\>
522 sc_prohibit_hash_without_use:
523         @h='hash.h' \
524         re='$(_hash_fn)|$(_hash_struct)'\
525           $(_sc_header_without_use)
526
527 sc_prohibit_cloexec_without_use:
528         @h='cloexec.h' re='\<(set_cloexec_flag|dup_cloexec) *\(' \
529           $(_sc_header_without_use)
530
531 sc_prohibit_posixver_without_use:
532         @h='posixver.h' re='\<posix2_version *\(' $(_sc_header_without_use)
533
534 sc_prohibit_same_without_use:
535         @h='same.h' re='\<same_name *\(' $(_sc_header_without_use)
536
537 sc_prohibit_hash_pjw_without_use:
538         @h='hash-pjw.h' \
539         re='\<hash_pjw\>' \
540           $(_sc_header_without_use)
541
542 sc_prohibit_safe_read_without_use:
543         @h='safe-read.h' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
544           $(_sc_header_without_use)
545
546 sc_prohibit_argmatch_without_use:
547         @h='argmatch.h' \
548         re='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<(invalid_arg|argmatch(_exit_fn|_(in)?valid)?) *\()' \
549           $(_sc_header_without_use)
550
551 sc_prohibit_canonicalize_without_use:
552         @h='canonicalize.h' \
553         re='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode|file_name)' \
554           $(_sc_header_without_use)
555
556 sc_prohibit_root_dev_ino_without_use:
557         @h='root-dev-ino.h' \
558         re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
559           $(_sc_header_without_use)
560
561 sc_prohibit_openat_without_use:
562         @h='openat.h' \
563         re='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat)\>' \
564           $(_sc_header_without_use)
565
566 # Prohibit the inclusion of c-ctype.h without an actual use.
567 ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
568 |isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
569 sc_prohibit_c_ctype_without_use:
570         @h='c-ctype.h' re='\<c_($(ctype_re)) *\(' \
571           $(_sc_header_without_use)
572
573 _empty =
574 _sp = $(_empty) $(_empty)
575 # The following list was generated by running:
576 # man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
577 #   | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
578 _sig_functions = \
579   bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
580   sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
581   siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
582   sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
583 _sig_function_re = $(subst $(_sp),|,$(strip $(_sig_functions)))
584 # The following were extracted from "man signal.h" manually.
585 _sig_types_and_consts =                                                 \
586   MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK           \
587   SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL            \
588   SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE    \
589   SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t  \
590   sigstack sigval stack_t ucontext_t
591 # generated via this:
592 # perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
593 _sig_names =                                                            \
594   SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT      \
595   SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL       \
596   SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP  \
597   SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR      \
598   SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS   \
599   SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1        \
600   SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW       \
601   SIGXCPU SIGXFSZ
602 _sig_syms_re = $(subst $(_sp),|,$(strip $(_sig_names) $(_sig_types_and_consts)))
603
604 # Prohibit the inclusion of signal.h without an actual use.
605 sc_prohibit_signal_without_use:
606         @h='signal.h'                                                   \
607         re='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>'          \
608           $(_sc_header_without_use)
609
610 # Don't include stdio--.h unless you use one of its functions.
611 sc_prohibit_stdio--_without_use:
612         @h='stdio--.h' re='\<((f(re)?|p)open|tmpfile) *\('              \
613           $(_sc_header_without_use)
614
615 # Don't include stdio-safer.h unless you use one of its functions.
616 sc_prohibit_stdio-safer_without_use:
617         @h='stdio-safer.h' re='\<((f(re)?|p)open|tmpfile)_safer *\('    \
618           $(_sc_header_without_use)
619
620 # Prohibit the inclusion of strings.h without a sensible use.
621 # Using the likes of bcmp, bcopy, bzero, index or rindex is not sensible.
622 sc_prohibit_strings_without_use:
623         @h='strings.h'                                                  \
624         re='\<(strn?casecmp|ffs(ll)?)\>'                                \
625           $(_sc_header_without_use)
626
627 # Get the list of symbol names with this:
628 # perl -lne '/^# *define ([A-Z]\w+)\(/ and print $1' lib/intprops.h|fmt
629 _intprops_names =                                                       \
630   TYPE_IS_INTEGER TYPE_TWOS_COMPLEMENT TYPE_ONES_COMPLEMENT             \
631   TYPE_SIGNED_MAGNITUDE TYPE_SIGNED TYPE_MINIMUM TYPE_MAXIMUM           \
632   INT_BITS_STRLEN_BOUND INT_STRLEN_BOUND INT_BUFSIZE_BOUND              \
633   INT_ADD_RANGE_OVERFLOW INT_SUBTRACT_RANGE_OVERFLOW                    \
634   INT_NEGATE_RANGE_OVERFLOW INT_MULTIPLY_RANGE_OVERFLOW                 \
635   INT_DIVIDE_RANGE_OVERFLOW INT_REMAINDER_RANGE_OVERFLOW                \
636   INT_LEFT_SHIFT_RANGE_OVERFLOW INT_ADD_OVERFLOW INT_SUBTRACT_OVERFLOW  \
637   INT_NEGATE_OVERFLOW INT_MULTIPLY_OVERFLOW INT_DIVIDE_OVERFLOW         \
638   INT_REMAINDER_OVERFLOW INT_LEFT_SHIFT_OVERFLOW
639 _intprops_syms_re = $(subst $(_sp),|,$(strip $(_intprops_names)))
640 # Prohibit the inclusion of intprops.h without an actual use.
641 sc_prohibit_intprops_without_use:
642         @h='intprops.h'                                                 \
643         re='\<($(_intprops_syms_re)) *\('                               \
644           $(_sc_header_without_use)
645
646 _stddef_syms_re = NULL|offsetof|ptrdiff_t|size_t|wchar_t
647 # Prohibit the inclusion of stddef.h without an actual use.
648 sc_prohibit_stddef_without_use:
649         @h='stddef.h'                                                   \
650         re='\<($(_stddef_syms_re))\>'                                   \
651           $(_sc_header_without_use)
652
653 _de1 = dirfd|(close|(fd)?open|read|rewind|seek|tell)dir(64)?(_r)?
654 _de2 = (versionsort|struct dirent|getdirentries|alphasort|scandir(at)?)(64)?
655 _de3 = MAXNAMLEN|DIR|ino_t|d_ino|d_fileno|d_namlen
656 _dirent_syms_re = $(_de1)|$(_de2)|$(_de3)
657 # Prohibit the inclusion of dirent.h without an actual use.
658 sc_prohibit_dirent_without_use:
659         @h='dirent.h'                                                   \
660         re='\<($(_dirent_syms_re))\>'                                   \
661           $(_sc_header_without_use)
662
663 # Prohibit the inclusion of verify.h without an actual use.
664 sc_prohibit_verify_without_use:
665         @h='verify.h'                                                   \
666         re='\<(verify(true|expr)?|static_assert) *\('                   \
667           $(_sc_header_without_use)
668
669 # Don't include xfreopen.h unless you use one of its functions.
670 sc_prohibit_xfreopen_without_use:
671         @h='xfreopen.h' re='\<xfreopen *\(' $(_sc_header_without_use)
672
673 sc_obsolete_symbols:
674         @prohibit='\<(HAVE''_FCNTL_H|O''_NDELAY)\>'                     \
675         halt='do not use HAVE''_FCNTL_H or O'_NDELAY                    \
676           $(_sc_search_regexp)
677
678 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
679
680 # Each nonempty ChangeLog line must start with a year number, or a TAB.
681 sc_changelog:
682         @prohibit='^[^12        ]'                                      \
683         in_vc_files='^ChangeLog$$'                                      \
684         halt='found unexpected prefix in a ChangeLog'                   \
685           $(_sc_search_regexp)
686
687 # Ensure that each .c file containing a "main" function also
688 # calls set_program_name.
689 sc_program_name:
690         @require='set_program_name *\(m?argv\[0\]\);'                   \
691         in_vc_files='\.c$$'                                             \
692         containing='\<main *('                                          \
693         halt='the above files do not call set_program_name'             \
694           $(_sc_search_regexp)
695
696 # Ensure that each .c file containing a "main" function also
697 # calls bindtextdomain.
698 sc_bindtextdomain:
699         @require='bindtextdomain *\('                                   \
700         in_vc_files='\.c$$'                                             \
701         containing='\<main *('                                          \
702         halt='the above files do not call bindtextdomain'               \
703           $(_sc_search_regexp)
704
705 # Require that the final line of each test-lib.sh-using test be this one:
706 # Exit $fail
707 # Note: this test requires GNU grep's --label= option.
708 Exit_witness_file ?= tests/test-lib.sh
709 Exit_base := $(notdir $(Exit_witness_file))
710 sc_require_test_exit_idiom:
711         @if test -f $(srcdir)/$(Exit_witness_file); then                \
712           die=0;                                                        \
713           for i in $$(grep -l -F 'srcdir/$(Exit_base)'                  \
714                 $$($(VC_LIST) tests)); do                               \
715             tail -n1 $$i | grep '^Exit .' > /dev/null                   \
716               && : || { die=1; echo $$i; }                              \
717           done;                                                         \
718           test $$die = 1 &&                                             \
719             { echo 1>&2 '$(ME): the final line in each of the above is not:'; \
720               echo 1>&2 'Exit something';                               \
721               exit 1; } || :;                                           \
722         fi
723
724 sc_trailing_blank:
725         @prohibit='[     ]$$'                                           \
726         halt='found trailing blank(s)'                                  \
727           $(_sc_search_regexp)
728
729 # Match lines like the following, but where there is only one space
730 # between the options and the description:
731 #   -D, --all-repeated[=delimit-method]  print all duplicate lines\n
732 longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*\]?)?
733 sc_two_space_separator_in_usage:
734         @prohibit='^   *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$'         \
735         halt='help2man requires at least two spaces between an option and its description'\
736           $(_sc_search_regexp)
737
738 # A regexp matching function names like "error" that may be used
739 # to emit translatable messages.
740 _gl_translatable_diag_func_re ?= error
741
742 # Look for diagnostics that aren't marked for translation.
743 # This won't find any for which error's format string is on a separate line.
744 sc_unmarked_diagnostics:
745         @prohibit='\<$(_gl_translatable_diag_func_re) *\([^"]*"[^"]*[a-z]{3}' \
746         exclude='(_|ngettext ?)\('                                      \
747         halt='found unmarked diagnostic(s)'                             \
748           $(_sc_search_regexp)
749
750 # Avoid useless parentheses like those in this example:
751 # #if defined (SYMBOL) || defined (SYM2)
752 sc_useless_cpp_parens:
753         @prohibit='^# *if .*defined *\('                                \
754         halt='found useless parentheses in cpp directive'               \
755           $(_sc_search_regexp)
756
757 # List headers for which HAVE_HEADER_H is always true, assuming you are
758 # using the appropriate gnulib module.  CAUTION: for each "unnecessary"
759 # #if HAVE_HEADER_H that you remove, be sure that your project explicitly
760 # requires the gnulib module that guarantees the usability of that header.
761 gl_assured_headers_ = \
762   cd $(gnulib_dir)/lib && echo *.in.h|sed 's/\.in\.h//g'
763
764 # Convert the list of names to upper case, and replace each space with "|".
765 az_ = abcdefghijklmnopqrstuvwxyz
766 AZ_ = ABCDEFGHIJKLMNOPQRSTUVWXYZ
767 gl_header_upper_case_or_ =                                              \
768   $$($(gl_assured_headers_)                                             \
769     | tr $(az_)/.- $(AZ_)___                                            \
770     | tr -s ' ' '|'                                                     \
771     )
772 sc_prohibit_always_true_header_tests:
773         @or=$(gl_header_upper_case_or_);                                \
774         re="HAVE_($$or)_H";                                             \
775         prohibit='\<'"$$re"'\>'                                         \
776         halt=$$(printf '%s\n'                                           \
777         'do not test the above HAVE_<header>_H symbol(s);'              \
778         '  with the corresponding gnulib module, they are always true') \
779           $(_sc_search_regexp)
780
781 sc_prohibit_defined_have_decl_tests:
782         @prohibit='#[    ]*if(n?def|.*\<defined)\>[      (]+HAVE_DECL_' \
783         halt='HAVE_DECL macros are always defined'                      \
784           $(_sc_search_regexp)
785
786 # ==================================================================
787 gl_other_headers_ ?= \
788   intprops.h    \
789   openat.h      \
790   stat-macros.h
791
792 # Perl -lne code to extract "significant" cpp-defined symbols from a
793 # gnulib header file, eliminating a few common false-positives.
794 # The exempted names below are defined only conditionally in gnulib,
795 # and hence sometimes must/may be defined in application code.
796 gl_extract_significant_defines_ = \
797   /^\# *define ([^_ (][^ (]*)(\s*\(|\s+\w+)/\
798     && $$2 !~ /(?:rpl_|_used_without_)/\
799     && $$1 !~ /^(?:NSIG|ENODATA)$$/\
800     && $$1 !~ /^(?:SA_RESETHAND|SA_RESTART)$$/\
801     and print $$1
802
803 # Create a list of regular expressions matching the names
804 # of macros that are guaranteed to be defined by parts of gnulib.
805 define def_sym_regex
806         gen_h=$(gl_generated_headers_);                                 \
807         (cd $(gnulib_dir)/lib;                                          \
808           for f in *.in.h $(gl_other_headers_); do                      \
809             test -f $$f                                                 \
810               && perl -lne '$(gl_extract_significant_defines_)' $$f;    \
811           done;                                                         \
812         ) | sort -u                                                     \
813           | sed 's/^/^ *# *(define|undef)  */;s/$$/\\>/'
814 endef
815
816 # Don't define macros that we already get from gnulib header files.
817 sc_prohibit_always-defined_macros:
818         @if test -d $(gnulib_dir); then                                 \
819           case $$(echo all: | grep -l -f - Makefile) in Makefile);; *)  \
820             echo '$(ME): skipping $@: you lack GNU grep' 1>&2; exit 0;; \
821           esac;                                                         \
822           $(def_sym_regex) | grep -E -f - $$($(VC_LIST_EXCEPT))         \
823             && { echo '$(ME): define the above via some gnulib .h file' \
824                   1>&2;  exit 1; } || :;                                \
825         fi
826 # ==================================================================
827
828 # Prohibit checked in backup files.
829 sc_prohibit_backup_files:
830         @$(VC_LIST) | grep '~$$' &&                             \
831           { echo '$(ME): found version controlled backup file' 1>&2;    \
832             exit 1; } || :
833
834 # Require the latest GPL.
835 sc_GPL_version:
836         @prohibit='either ''version [^3]'                               \
837         halt='GPL vN, N!=3'                                             \
838           $(_sc_search_regexp)
839
840 # Require the latest GFDL.  Two regexp, since some .texi files end up
841 # line wrapping between 'Free Documentation License,' and 'Version'.
842 _GFDL_regexp = (Free ''Documentation.*Version 1\.[^3]|Version 1\.[^3] or any)
843 sc_GFDL_version:
844         @prohibit='$(_GFDL_regexp)'                                     \
845         halt='GFDL vN, N!=3'                                            \
846           $(_sc_search_regexp)
847
848 # Don't use Texinfo's @acronym{}.
849 # http://lists.gnu.org/archive/html/bug-gnulib/2010-03/msg00321.html
850 texinfo_suffix_re_ ?= \.(txi|texi(nfo)?)$$
851 sc_texinfo_acronym:
852         @prohibit='@acronym\{'                                          \
853         in_vc_files='$(texinfo_suffix_re_)'                             \
854         halt='found use of Texinfo @acronym{}'                          \
855           $(_sc_search_regexp)
856
857 cvs_keywords = \
858   Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
859
860 sc_prohibit_cvs_keyword:
861         @prohibit='\$$($(cvs_keywords))\$$'                             \
862         halt='do not use CVS keyword expansion'                         \
863           $(_sc_search_regexp)
864
865 # This Perl code is slightly obfuscated.  Not only is each "$" doubled
866 # because it's in a Makefile, but the $$c's are comments;  we cannot
867 # use "#" due to the way the script ends up concatenated onto one line.
868 # It would be much more concise, and would produce better output (including
869 # counts) if written as:
870 #   perl -ln -0777 -e '/\n(\n+)$/ and print "$ARGV: ".length $1' ...
871 # but that would be far less efficient, reading the entire contents
872 # of each file, rather than just the last two bytes of each.
873 # In addition, while the code below detects both blank lines and a missing
874 # newline at EOF, the above detects only the former.
875 #
876 # This is a perl script that is expected to be the single-quoted argument
877 # to a command-line "-le".  The remaining arguments are file names.
878 # Print the name of each file that does not end in exactly one newline byte.
879 # I.e., warn if there are blank lines (2 or more newlines), or if the
880 # last byte is not a newline.  However, currently we don't complain
881 # about any file that contains exactly one byte.
882 # Exit nonzero if at least one such file is found, otherwise, exit 0.
883 # Warn about, but otherwise ignore open failure.  Ignore seek/read failure.
884 #
885 # Use this if you want to remove trailing empty lines from selected files:
886 #   perl -pi -0777 -e 's/\n\n+$/\n/' files...
887 #
888 require_exactly_one_NL_at_EOF_ =                                        \
889   foreach my $$f (@ARGV)                                                \
890     {                                                                   \
891       open F, "<", $$f or (warn "failed to open $$f: $$!\n"), next;     \
892       my $$p = sysseek (F, -2, 2);                                      \
893       my $$c = "seek failure probably means file has < 2 bytes; ignore"; \
894       my $$last_two_bytes;                                              \
895       defined $$p and $$p = sysread F, $$last_two_bytes, 2;             \
896       close F;                                                          \
897       $$c = "ignore read failure";                                      \
898       $$p && ($$last_two_bytes eq "\n\n"                                \
899               || substr ($$last_two_bytes,1) ne "\n")                   \
900           and (print $$f), $$fail=1;                                    \
901     }                                                                   \
902   END { exit defined $$fail }
903 sc_prohibit_empty_lines_at_EOF:
904         @perl -le '$(require_exactly_one_NL_at_EOF_)' $$($(VC_LIST_EXCEPT)) \
905           || { echo '$(ME): empty line(s) or no newline at EOF'         \
906                 1>&2; exit 1; } || :
907
908 # Make sure we don't use st_blocks.  Use ST_NBLOCKS instead.
909 # This is a bit of a kludge, since it prevents use of the string
910 # even in comments, but for now it does the job with no false positives.
911 sc_prohibit_stat_st_blocks:
912         @prohibit='[.>]st_blocks'                                       \
913         halt='do not use st_blocks; use ST_NBLOCKS'                     \
914           $(_sc_search_regexp)
915
916 # Make sure we don't define any S_IS* macros in src/*.c files.
917 # They're already defined via gnulib's sys/stat.h replacement.
918 sc_prohibit_S_IS_definition:
919         @prohibit='^ *# *define  *S_IS'                                 \
920         halt='do not define S_IS* macros; include <sys/stat.h>'         \
921           $(_sc_search_regexp)
922
923 # Perl block to convert a match to FILE_NAME:LINENO:TEST,
924 # that is shared by two definitions below.
925 perl_filename_lineno_text_ =                                            \
926     -e '  {'                                                            \
927     -e '    $$n = ($$` =~ tr/\n/\n/ + 1);'                              \
928     -e '    ($$v = $$&) =~ s/\n/\\n/g;'                                 \
929     -e '    print "$$ARGV:$$n:$$v\n";'                                  \
930     -e '  }'
931
932 prohibit_doubled_word_RE_ ?= \
933   /\b(then?|[iao]n|i[fst]|but|f?or|at|and|[dt]o)\s+\1\b/gims
934 prohibit_doubled_word_ =                                                \
935     -e 'while ($(prohibit_doubled_word_RE_))'                           \
936     $(perl_filename_lineno_text_)
937
938 # Define this to a regular expression that matches
939 # any filename:dd:match lines you want to ignore.
940 # The default is to ignore no matches.
941 ignore_doubled_word_match_RE_ ?= ^$$
942
943 sc_prohibit_doubled_word:
944         @perl -n -0777 $(prohibit_doubled_word_) $$($(VC_LIST_EXCEPT))  \
945           | grep -vE '$(ignore_doubled_word_match_RE_)'                 \
946           | grep . && { echo '$(ME): doubled words' 1>&2; exit 1; } || :
947
948 # A regular expression matching undesirable combinations of words like
949 # "can not"; this matches them even when the two words appear on different
950 # lines, but not when there is an intervening delimiter like "#" or "*".
951 # Similarly undesirable, "See @xref{...}", since an @xref should start
952 # a sentence.  Explicitly prohibit any prefix of "see" or "also".
953 # Also prohibit a prefix matching "\w+ +".
954 # @pxref gets the same see/also treatment and should be parenthesized;
955 # presume it must *not* start a sentence.
956 bad_xref_re_ ?= (?:[\w,:;] +|(?:see|also)\s+)\@xref\{
957 bad_pxref_re_ ?= (?:[.!?]|(?:see|also))\s+\@pxref\{
958 prohibit_undesirable_word_seq_RE_ ?=                                    \
959   /(?:\bcan\s+not\b|$(bad_xref_re_)|$(bad_pxref_re_))/gims
960 prohibit_undesirable_word_seq_ =                                        \
961     -e 'while ($(prohibit_undesirable_word_seq_RE_))'                   \
962     $(perl_filename_lineno_text_)
963 # Define this to a regular expression that matches
964 # any filename:dd:match lines you want to ignore.
965 # The default is to ignore no matches.
966 ignore_undesirable_word_sequence_RE_ ?= ^$$
967
968 sc_prohibit_undesirable_word_seq:
969         @perl -n -0777 $(prohibit_undesirable_word_seq_)                \
970              $$($(VC_LIST_EXCEPT))                                      \
971           | grep -vE '$(ignore_undesirable_word_sequence_RE_)' | grep . \
972           && { echo '$(ME): undesirable word sequence' >&2; exit 1; } || :
973
974 _ptm1 = use "test C1 && test C2", not "test C1 -''a C2"
975 _ptm2 = use "test C1 || test C2", not "test C1 -''o C2"
976 # Using test's -a and -o operators is not portable.
977 # We prefer test over [, since the latter is spelled [[ in configure.ac.
978 sc_prohibit_test_minus_ao:
979         @prohibit='(\<test| \[+) .+ -[ao] '                             \
980         halt='$(_ptm1); $(_ptm2)'                                       \
981           $(_sc_search_regexp)
982
983 # Avoid a test bashism.
984 sc_prohibit_test_double_equal:
985         @prohibit='(\<test| \[+) .+ == '                                \
986         containing='#! */bin/[a-z]*sh'                                  \
987         halt='use "test x = x", not "test x =''= x"'                    \
988           $(_sc_search_regexp)
989
990 # Each program that uses proper_name_utf8 must link with one of the
991 # ICONV libraries.  Otherwise, some ICONV library must appear in LDADD.
992 # The perl -0777 invocation below extracts the possibly-multi-line
993 # definition of LDADD from the appropriate Makefile.am and exits 0
994 # when it contains "ICONV".
995 sc_proper_name_utf8_requires_ICONV:
996         @progs=$$(grep -l 'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT)));\
997         if test "x$$progs" != x; then                                   \
998           fail=0;                                                       \
999           for p in $$progs; do                                          \
1000             dir=$$(dirname "$$p");                                      \
1001             perl -0777                                                  \
1002               -ne 'exit !(/^LDADD =(.+?[^\\]\n)/ms && $$1 =~ /ICONV/)'  \
1003               $$dir/Makefile.am && continue;                            \
1004             base=$$(basename "$$p" .c);                                 \
1005             grep "$${base}_LDADD.*ICONV)" $$dir/Makefile.am > /dev/null \
1006               || { fail=1; echo 1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
1007           done;                                                         \
1008           test $$fail = 1 &&                                            \
1009             { echo 1>&2 '$(ME): the above do not link with any ICONV library'; \
1010               exit 1; } || :;                                           \
1011         fi
1012
1013 # Warn about "c0nst struct Foo const foo[]",
1014 # but not about "char const *const foo" or "#define const const".
1015 sc_redundant_const:
1016         @prohibit='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b'          \
1017         halt='redundant "const" in declarations'                        \
1018           $(_sc_search_regexp)
1019
1020 sc_const_long_option:
1021         @prohibit='^ *static.*struct option '                           \
1022         exclude='const struct option|struct option const'               \
1023         halt='add "const" to the above declarations'                    \
1024           $(_sc_search_regexp)
1025
1026 NEWS_hash =                                                             \
1027   $$(sed -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p'              \
1028        $(srcdir)/NEWS                                                   \
1029      | perl -0777 -pe                                                   \
1030         's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms'       \
1031      | md5sum -                                                         \
1032      | sed 's/ .*//')
1033
1034 # Ensure that we don't accidentally insert an entry into an old NEWS block.
1035 sc_immutable_NEWS:
1036         @if test -f $(srcdir)/NEWS; then                                \
1037           test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : ||              \
1038             { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; }; \
1039         fi
1040
1041 # Update the hash stored above.  Do this after each release and
1042 # for any corrections to old entries.
1043 update-NEWS-hash: NEWS
1044         perl -pi -e 's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
1045           $(srcdir)/cfg.mk
1046
1047 # Ensure that we use only the standard $(VAR) notation,
1048 # not @...@ in Makefile.am, now that we can rely on automake
1049 # to emit a definition for each substituted variable.
1050 # However, there is still one case in which @VAR@ use is not just
1051 # legitimate, but actually required: when augmenting an automake-defined
1052 # variable with a prefix.  For example, gettext uses this:
1053 # MAKEINFO = env LANG= LC_MESSAGES= LC_ALL= LANGUAGE= @MAKEINFO@
1054 # otherwise, makeinfo would put German or French (current locale)
1055 # navigation hints in the otherwise-English documentation.
1056 #
1057 # Allow the package to add exceptions via a hook in cfg.mk;
1058 # for example, @PRAGMA_SYSTEM_HEADER@ can be permitted by
1059 # setting this to ' && !/PRAGMA_SYSTEM_HEADER/'.
1060 _makefile_at_at_check_exceptions ?=
1061 sc_makefile_at_at_check:
1062         @perl -ne '/\@\w+\@/'                                           \
1063           -e ' && !/(\w+)\s+=.*\@\1\@$$/'                               \
1064           -e ''$(_makefile_at_at_check_exceptions)                      \
1065           -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}'    \
1066             $$($(VC_LIST_EXCEPT) | grep -E '(^|/)(Makefile\.am|[^/]+\.mk)$$') \
1067           && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
1068
1069 news-check: NEWS
1070         $(AM_V_GEN)if sed -n $(news-check-lines-spec)p $<               \
1071             | grep -E $(news-check-regexp) >/dev/null; then             \
1072           :;                                                            \
1073         else                                                            \
1074           echo 'NEWS: $$(news-check-regexp) failed to match' 1>&2;      \
1075           exit 1;                                                       \
1076         fi
1077
1078 sc_makefile_TAB_only_indentation:
1079         @prohibit='^    [ ]{8}'                                         \
1080         in_vc_files='akefile|\.mk$$'                                    \
1081         halt='found TAB-8-space indentation'                            \
1082           $(_sc_search_regexp)
1083
1084 sc_m4_quote_check:
1085         @prohibit='(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]'              \
1086         in_vc_files='(^configure\.ac|\.m4)$$'                           \
1087         halt='quote the first arg to AC_DEF*'                           \
1088           $(_sc_search_regexp)
1089
1090 fix_po_file_diag = \
1091 'you have changed the set of files with translatable diagnostics;\n\
1092 apply the above patch\n'
1093
1094 # Verify that all source files using _() are listed in po/POTFILES.in.
1095 po_file ?= $(srcdir)/po/POTFILES.in
1096 generated_files ?= $(srcdir)/lib/*.[ch]
1097 sc_po_check:
1098         @if test -f $(po_file); then                                    \
1099           grep -E -v '^(#|$$)' $(po_file)                               \
1100             | grep -v '^src/false\.c$$' | sort > $@-1;                  \
1101           files=;                                                       \
1102           for file in $$($(VC_LIST_EXCEPT)) $(generated_files); do      \
1103             test -r $$file || continue;                                 \
1104             case $$file in                                              \
1105               *.m4|*.mk) continue ;;                                    \
1106               *.?|*.??) ;;                                              \
1107               *) continue;;                                             \
1108             esac;                                                       \
1109             case $$file in                                              \
1110             *.[ch])                                                     \
1111               base=`expr " $$file" : ' \(.*\)\..'`;                     \
1112               { test -f $$base.l || test -f $$base.y; } && continue;;   \
1113             esac;                                                       \
1114             files="$$files $$file";                                     \
1115           done;                                                         \
1116           grep -E -l '\b(N?_|gettext *)\([^)"]*("|$$)' $$files          \
1117             | sed 's|^$(_dot_escaped_srcdir)/||' | sort -u > $@-2;      \
1118           diff -u -L $(po_file) -L $(po_file) $@-1 $@-2                 \
1119             || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; };   \
1120           rm -f $@-1 $@-2;                                              \
1121         fi
1122
1123 # Sometimes it is useful to change the PATH environment variable
1124 # in Makefiles.  When doing so, it's better not to use the Unix-centric
1125 # path separator of ':', but rather the automake-provided '$(PATH_SEPARATOR)'.
1126 msg = 'Do not use ":" above; use $$(PATH_SEPARATOR) instead'
1127 sc_makefile_path_separator_check:
1128         @prohibit='PATH[=].*:'                                          \
1129         in_vc_files='akefile|\.mk$$'                                    \
1130         halt=$(msg)                                                     \
1131           $(_sc_search_regexp)
1132
1133 # Check that 'make alpha' will not fail at the end of the process,
1134 # i.e., when pkg-M.N.tar.xz already exists (either in "." or in ../release)
1135 # and is read-only.
1136 writable-files:
1137         if test -d $(release_archive_dir); then                         \
1138           for file in $(DIST_ARCHIVES); do                              \
1139             for p in ./ $(release_archive_dir)/; do                     \
1140               test -e $$p$$file || continue;                            \
1141               test -w $$p$$file                                         \
1142                 || { echo ERROR: $$p$$file is not writable; fail=1; };  \
1143             done;                                                       \
1144           done;                                                         \
1145           test "$$fail" && exit 1 || : ;                                \
1146         else :;                                                         \
1147         fi
1148
1149 v_etc_file = $(gnulib_dir)/lib/version-etc.c
1150 sample-test = tests/sample-test
1151 texi = doc/$(PACKAGE).texi
1152 # Make sure that the copyright date in $(v_etc_file) is up to date.
1153 # Do the same for the $(sample-test) and the main doc/.texi file.
1154 sc_copyright_check:
1155         @require='enum { COPYRIGHT_YEAR = '$$(date +%Y)' };'            \
1156         in_files=$(v_etc_file)                                          \
1157         halt='out of date copyright in $(v_etc_file); update it'        \
1158           $(_sc_search_regexp)
1159         @require='# Copyright \(C\) '$$(date +%Y)' Free'                \
1160         in_vc_files=$(sample-test)                                      \
1161         halt='out of date copyright in $(sample-test); update it'       \
1162           $(_sc_search_regexp)
1163         @require='Copyright @copyright\{\} .*'$$(date +%Y)' Free'       \
1164         in_vc_files=$(texi)                                             \
1165         halt='out of date copyright in $(texi); update it'              \
1166           $(_sc_search_regexp)
1167
1168 # If tests/help-version exists and seems to be new enough, assume that its
1169 # use of init.sh and path_prepend_ is correct, and ensure that every other
1170 # use of init.sh is identical.
1171 # This is useful because help-version cross-checks prog --version
1172 # with $(VERSION), which verifies that its path_prepend_ invocation
1173 # sets PATH correctly.  This is an inexpensive way to ensure that
1174 # the other init.sh-using tests also get it right.
1175 _hv_file ?= $(srcdir)/tests/help-version
1176 _hv_regex_weak ?= ^ *\. .*/init\.sh"
1177 # Fix syntax-highlighters "
1178 _hv_regex_strong ?= ^ *\. "\$${srcdir=\.}/init\.sh"
1179 sc_cross_check_PATH_usage_in_tests:
1180         @if test -f $(_hv_file); then                                   \
1181           grep -l 'VERSION mismatch' $(_hv_file) >/dev/null             \
1182             || { echo "$@: skipped: no such file: $(_hv_file)" 1>&2;    \
1183                  exit 0; };                                             \
1184           grep -lE '$(_hv_regex_strong)' $(_hv_file) >/dev/null         \
1185             || { echo "$@: $(_hv_file) lacks conforming use of init.sh" 1>&2; \
1186                  exit 1; };                                             \
1187           good=$$(grep -E '$(_hv_regex_strong)' $(_hv_file));           \
1188           grep -LFx "$$good"                                            \
1189                 $$(grep -lE '$(_hv_regex_weak)' $$($(VC_LIST_EXCEPT)))  \
1190               | grep . &&                                               \
1191             { echo "$(ME): the above files use path_prepend_ inconsistently" \
1192                 1>&2; exit 1; } || :;                                   \
1193         fi
1194
1195 # BRE regex of file contents to identify a test script.
1196 _test_script_regex ?= \<init\.sh\>
1197
1198 # In tests, use "compare expected actual", not the reverse.
1199 sc_prohibit_reversed_compare_failure:
1200         @prohibit='\<compare [^ ]+ ([^ ]*exp|/dev/null)'                \
1201         containing='$(_test_script_regex)'                              \
1202         halt='reversed compare arguments'                               \
1203           $(_sc_search_regexp)
1204
1205 # #if HAVE_... will evaluate to false for any non numeric string.
1206 # That would be flagged by using -Wundef, however gnulib currently
1207 # tests many undefined macros, and so we can't enable that option.
1208 # So at least preclude common boolean strings as macro values.
1209 sc_Wundef_boolean:
1210         @prohibit='^#define.*(yes|no|true|false)$$'                     \
1211         in_files='$(CONFIG_INCLUDE)'                                    \
1212         halt='Use 0 or 1 for macro values'                              \
1213           $(_sc_search_regexp)
1214
1215 # Even if you use pathmax.h to guarantee that PATH_MAX is defined, it might
1216 # not be constant, or might overflow a stack.  In general, use PATH_MAX as
1217 # a limit, not an array or alloca size.
1218 sc_prohibit_path_max_allocation:
1219         @prohibit='(\balloca *\([^)]*|\[[^]]*)PATH_MAX'                 \
1220         halt='Avoid stack allocations of size PATH_MAX'                 \
1221           $(_sc_search_regexp)
1222
1223 sc_vulnerable_makefile_CVE-2009-4029:
1224         @prohibit='perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \
1225         in_files='(^|/)Makefile\.in$$'                                  \
1226         halt=$$(printf '%s\n'                                           \
1227           'the above files are vulnerable; beware of running'           \
1228           '  "make dist*" rules, and upgrade to fixed automake'         \
1229           '  see http://bugzilla.redhat.com/542609 for details')        \
1230           $(_sc_search_regexp)
1231
1232 sc_vulnerable_makefile_CVE-2012-3386:
1233         @prohibit='chmod a\+w \$$\(distdir\)'                           \
1234         in_files='(^|/)Makefile\.in$$'                                  \
1235         halt=$$(printf '%s\n'                                           \
1236           'the above files are vulnerable; beware of running'           \
1237           '  "make distcheck", and upgrade to fixed automake'           \
1238           '  see http://bugzilla.redhat.com/CVE-2012-3386 for details') \
1239           $(_sc_search_regexp)
1240
1241 vc-diff-check:
1242         $(AM_V_GEN)(unset CDPATH; cd $(srcdir) && $(VC) diff) > vc-diffs || :
1243         $(AM_V_at)if test -s vc-diffs; then                     \
1244           cat vc-diffs;                                         \
1245           echo "Some files are locally modified:" 1>&2;         \
1246           exit 1;                                               \
1247         else                                                    \
1248           rm vc-diffs;                                          \
1249         fi
1250
1251 rel-files = $(DIST_ARCHIVES)
1252
1253 gnulib_dir ?= $(srcdir)/gnulib
1254 gnulib-version = $$(cd $(gnulib_dir) && git describe)
1255 bootstrap-tools ?= autoconf,automake,gnulib
1256
1257 # If it's not already specified, derive the GPG key ID from
1258 # the signed tag we've just applied to mark this release.
1259 gpg_key_ID ?=                                                           \
1260   $$(cd $(srcdir)                                                       \
1261      && git cat-file tag v$(VERSION)                                    \
1262         | gpgv --status-fd 1 --keyring /dev/null - - 2>/dev/null        \
1263         | awk '/^\[GNUPG:\] ERRSIG / {print $$3; exit}')
1264
1265 translation_project_ ?= coordinator@translationproject.org
1266
1267 # Make info-gnu the default only for a stable release.
1268 ifeq ($(RELEASE_TYPE),stable)
1269   announcement_Cc_ ?= $(translation_project_), $(PACKAGE_BUGREPORT)
1270   announcement_mail_headers_ ?=                                         \
1271     To: info-gnu@gnu.org                                                \
1272     Cc: $(announcement_Cc_)                                             \
1273     Mail-Followup-To: $(PACKAGE_BUGREPORT)
1274 else
1275   announcement_Cc_ ?= $(translation_project_)
1276   announcement_mail_headers_ ?=                                         \
1277     To: $(PACKAGE_BUGREPORT)                                            \
1278     Cc: $(announcement_Cc_)
1279 endif
1280
1281 announcement: NEWS ChangeLog $(rel-files)
1282         $(AM_V_GEN)$(srcdir)/$(_build-aux)/announce-gen                 \
1283             --mail-headers='$(announcement_mail_headers_)'              \
1284             --release-type=$(RELEASE_TYPE)                              \
1285             --package=$(PACKAGE)                                        \
1286             --prev=$(PREV_VERSION)                                      \
1287             --curr=$(VERSION)                                           \
1288             --gpg-key-id=$(gpg_key_ID)                                  \
1289             --srcdir=$(srcdir)                                          \
1290             --news=$(srcdir)/NEWS                                       \
1291             --bootstrap-tools=$(bootstrap-tools)                        \
1292             $$(case ,$(bootstrap-tools), in (*,gnulib,*)                \
1293                echo --gnulib-version=$(gnulib-version);; esac)          \
1294             --no-print-checksums                                        \
1295             $(addprefix --url-dir=, $(url_dir_list))
1296
1297 .PHONY: release-commit
1298 release-commit:
1299         $(AM_V_GEN)cd $(srcdir)                         \
1300           && $(_build-aux)/do-release-commit-and-tag    \
1301                -C $(abs_builddir) $(RELEASE)
1302
1303 ## ---------------- ##
1304 ## Updating files.  ##
1305 ## ---------------- ##
1306
1307 ftp-gnu = ftp://ftp.gnu.org/gnu
1308 www-gnu = http://www.gnu.org
1309
1310 upload_dest_dir_ ?= $(PACKAGE)
1311 emit_upload_commands:
1312         @echo =====================================
1313         @echo =====================================
1314         @echo "$(srcdir)/$(_build-aux)/gnupload $(GNUPLOADFLAGS) \\"
1315         @echo "    --to $(gnu_rel_host):$(upload_dest_dir_) \\"
1316         @echo "  $(rel-files)"
1317         @echo '# send the ~/announce-$(my_distdir) e-mail'
1318         @echo =====================================
1319         @echo =====================================
1320
1321 define emit-commit-log
1322   printf '%s\n' 'maint: post-release administrivia' ''                  \
1323     '* NEWS: Add header line for next release.'                         \
1324     '* .prev-version: Record previous version.'                         \
1325     '* cfg.mk (old_NEWS_hash): Auto-update.'
1326 endef
1327
1328 .PHONY: no-submodule-changes
1329 no-submodule-changes:
1330         $(AM_V_GEN)if test -d $(srcdir)/.git; then                      \
1331           diff=$$(cd $(srcdir) && git submodule -q foreach              \
1332                   git diff-index --name-only HEAD)                      \
1333             || exit 1;                                                  \
1334           case $$diff in '') ;;                                         \
1335             *) echo '$(ME): submodule files are locally modified:';     \
1336                 echo "$$diff"; exit 1;; esac;                           \
1337         else                                                            \
1338           : ;                                                           \
1339         fi
1340
1341 submodule-checks ?= no-submodule-changes public-submodule-commit
1342
1343 # Ensure that each sub-module commit we're using is public.
1344 # Without this, it is too easy to tag and release code that
1345 # cannot be built from a fresh clone.
1346 .PHONY: public-submodule-commit
1347 public-submodule-commit:
1348         $(AM_V_GEN)if test -d $(srcdir)/.git; then                      \
1349           cd $(srcdir) &&                                               \
1350           git submodule --quiet foreach test '$$(git rev-parse $$sha1)' \
1351               = '$$(git merge-base origin $$sha1)'                      \
1352             || { echo '$(ME): found non-public submodule commit' >&2;   \
1353                  exit 1; };                                             \
1354         else                                                            \
1355           : ;                                                           \
1356         fi
1357 # This rule has a high enough utility/cost ratio that it should be a
1358 # dependent of "check" by default.  However, some of us do occasionally
1359 # commit a temporary change that deliberately points to a non-public
1360 # submodule commit, and want to be able to use rules like "make check".
1361 # In that case, run e.g., "make check gl_public_submodule_commit="
1362 # to disable this test.
1363 gl_public_submodule_commit ?= public-submodule-commit
1364 check: $(gl_public_submodule_commit)
1365
1366 .PHONY: alpha beta stable
1367 ALL_RECURSIVE_TARGETS += alpha beta stable
1368 alpha beta stable: $(local-check) writable-files $(submodule-checks)
1369         $(AM_V_GEN)test $@ = stable                                     \
1370           && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$'         \
1371                || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
1372           || :
1373         $(AM_V_at)$(MAKE) vc-diff-check
1374         $(AM_V_at)$(MAKE) news-check
1375         $(AM_V_at)$(MAKE) distcheck
1376         $(AM_V_at)$(MAKE) dist
1377         $(AM_V_at)$(MAKE) $(release-prep-hook) RELEASE_TYPE=$@
1378         $(AM_V_at)$(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
1379
1380 # Override this in cfg.mk if you follow different procedures.
1381 release-prep-hook ?= release-prep
1382
1383 gl_noteworthy_news_ = * Noteworthy changes in release ?.? (????-??-??) [?]
1384 .PHONY: release-prep
1385 release-prep:
1386         $(AM_V_GEN)case $$RELEASE_TYPE in alpha|beta|stable) ;; \
1387           *) echo "invalid RELEASE_TYPE: $$RELEASE_TYPE" 1>&2; exit 1;; esac
1388         $(AM_V_at)$(MAKE) --no-print-directory -s announcement \
1389           > ~/announce-$(my_distdir)
1390         $(AM_V_at)if test -d $(release_archive_dir); then       \
1391           ln $(rel-files) $(release_archive_dir);               \
1392           chmod a-w $(rel-files);                               \
1393         fi
1394         $(AM_V_at)echo $(VERSION) > $(prev_version_file)
1395         $(AM_V_at)$(MAKE) update-NEWS-hash
1396         $(AM_V_at)perl -pi                                              \
1397           -e '$$. == 3 and print "$(gl_noteworthy_news_)\n\n\n"'        \
1398           $(srcdir)/NEWS
1399         $(AM_V_at)msg=$$($(emit-commit-log)) || exit 1;         \
1400         cd $(srcdir) && $(VC) commit -m "$$msg" -a
1401
1402 # Override this with e.g., -s $(srcdir)/some_other_name.texi
1403 # if the default $(PACKAGE)-derived name doesn't apply.
1404 gendocs_options_ ?=
1405
1406 .PHONY: web-manual
1407 web-manual:
1408         $(AM_V_GEN)test -z "$(manual_title)" \
1409           && { echo define manual_title in cfg.mk 1>&2; exit 1; } || :
1410         $(AM_V_at)cd '$(srcdir)/doc'; \
1411           $(SHELL) ../$(_build-aux)/gendocs.sh $(gendocs_options_) \
1412              -o '$(abs_builddir)/doc/manual' \
1413              --email $(PACKAGE_BUGREPORT) $(PACKAGE) \
1414             "$(PACKAGE_NAME) - $(manual_title)"
1415         $(AM_V_at)echo " *** Upload the doc/manual directory to web-cvs."
1416
1417 .PHONY: web-manual-update
1418 web-manual-update:
1419         $(AM_V_GEN)cd $(srcdir) \
1420           && $(_build-aux)/gnu-web-doc-update -C $(abs_builddir)
1421
1422
1423 # Code Coverage
1424
1425 init-coverage:
1426         $(MAKE) $(AM_MAKEFLAGS) clean
1427         lcov --directory . --zerocounters
1428
1429 COVERAGE_CCOPTS ?= "-g --coverage"
1430 COVERAGE_OUT ?= doc/coverage
1431
1432 build-coverage:
1433         $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS)
1434         $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS) check
1435         mkdir -p $(COVERAGE_OUT)
1436         lcov --directory . --output-file $(COVERAGE_OUT)/$(PACKAGE).info \
1437                 --capture
1438
1439 gen-coverage:
1440         genhtml --output-directory $(COVERAGE_OUT) \
1441                 $(COVERAGE_OUT)/$(PACKAGE).info \
1442                 --highlight --frames --legend \
1443                 --title "$(PACKAGE_NAME)"
1444
1445 coverage: init-coverage build-coverage gen-coverage
1446
1447 # Some projects carry local adjustments for gnulib modules via patches in
1448 # a gnulib patch directory whose default name is gl/ (defined in bootstrap
1449 # via local_gl_dir=gl).  Those patches become stale as the originals evolve
1450 # in gnulib.  Use this rule to refresh any stale patches.  It applies each
1451 # patch to the original in $(gnulib_dir) and uses the temporary result to
1452 # generate a fuzz-free .diff file.  If you customize the name of your local
1453 # gnulib patch directory via bootstrap.conf, this rule detects that name.
1454 # Run this from a non-VPATH (i.e., srcdir) build directory.
1455 .PHONY: refresh-gnulib-patches
1456 refresh-gnulib-patches:
1457         gl=gl;                                                          \
1458         if test -f bootstrap.conf; then                                 \
1459           t=$$(perl -lne '/^\s*local_gl_dir=(\S+)/ and $$d=$$1;'        \
1460                -e 'END{defined $$d and print $$d}' bootstrap.conf);     \
1461           test -n "$$t" && gl=$$t;                                      \
1462         fi;                                                             \
1463         for diff in $$(cd $$gl; git ls-files | grep '\.diff$$'); do     \
1464           b=$$(printf %s "$$diff"|sed 's/\.diff$$//');                  \
1465           VERSION_CONTROL=none                                          \
1466             patch "$(gnulib_dir)/$$b" "$$gl/$$diff" || exit 1;          \
1467           ( cd $(gnulib_dir) || exit 1;                                 \
1468             git diff "$$b" > "../$$gl/$$diff";                          \
1469             git checkout $$b ) || exit 1;                               \
1470         done
1471
1472 # Update gettext files.
1473 PACKAGE ?= $(shell basename $(PWD))
1474 PO_DOMAIN ?= $(PACKAGE)
1475 POURL = http://translationproject.org/latest/$(PO_DOMAIN)/
1476 PODIR ?= po
1477 refresh-po:
1478         rm -f $(PODIR)/*.po && \
1479         echo "$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
1480         wget --no-verbose --directory-prefix $(PODIR) --no-directories --recursive --level 1 --accept .po --accept .po.1 $(POURL) && \
1481         echo 'en@boldquot' > $(PODIR)/LINGUAS && \
1482         echo 'en@quot' >> $(PODIR)/LINGUAS && \
1483         ls $(PODIR)/*.po | sed 's/\.po//;s,$(PODIR)/,,' | sort >> $(PODIR)/LINGUAS
1484
1485  # Running indent once is not idempotent, but running it twice is.
1486 INDENT_SOURCES ?= $(C_SOURCES)
1487 .PHONY: indent
1488 indent:
1489         indent $(INDENT_SOURCES)
1490         indent $(INDENT_SOURCES)
1491
1492 # If you want to set UPDATE_COPYRIGHT_* environment variables,
1493 # put the assignments in this variable.
1494 update-copyright-env ?=
1495
1496 # Run this rule once per year (usually early in January)
1497 # to update all FSF copyright year lists in your project.
1498 # If you have an additional project-specific rule,
1499 # add it in cfg.mk along with a line 'update-copyright: prereq'.
1500 # By default, exclude all variants of COPYING; you can also
1501 # add exemptions (such as ChangeLog..* for rotated change logs)
1502 # in the file .x-update-copyright.
1503 .PHONY: update-copyright
1504 update-copyright:
1505         $(AM_V_GEN)grep -l -w Copyright                                  \
1506           $$(export VC_LIST_EXCEPT_DEFAULT=COPYING && $(VC_LIST_EXCEPT)) \
1507           | $(update-copyright-env) xargs $(srcdir)/$(_build-aux)/$@
1508
1509 # This tight_scope test is skipped with a warning if $(_gl_TS_headers) is not
1510 # overridden and $(_gl_TS_dir)/Makefile.am does not mention noinst_HEADERS.
1511
1512 # NOTE: to override any _gl_TS_* default value, you must
1513 # define the variable(s) using "export" in cfg.mk.
1514 _gl_TS_dir ?= src
1515
1516 ALL_RECURSIVE_TARGETS += sc_tight_scope
1517 sc_tight_scope: tight-scope.mk
1518         @fail=0;                                                        \
1519         if ! grep '^ *export _gl_TS_headers *=' $(srcdir)/cfg.mk        \
1520                 > /dev/null                                             \
1521            && ! grep -w noinst_HEADERS $(srcdir)/$(_gl_TS_dir)/Makefile.am \
1522                 > /dev/null 2>&1; then                                  \
1523             echo '$(ME): skipping $@';                                  \
1524         else                                                            \
1525             $(MAKE) -s -C $(_gl_TS_dir)                                 \
1526                 -f Makefile                                             \
1527                 -f $(abs_top_srcdir)/cfg.mk                             \
1528                 -f $(abs_top_builddir)/$<                               \
1529               _gl_tight_scope                                           \
1530                 || fail=1;                                              \
1531         fi;                                                             \
1532         rm -f $<;                                                       \
1533         exit $$fail
1534
1535 tight-scope.mk: $(ME)
1536         @rm -f $@ $@-t
1537         @perl -ne '/^# TS-start/.../^# TS-end/ and print' $(srcdir)/$(ME) > $@-t
1538         @chmod a=r $@-t && mv $@-t $@
1539
1540 ifeq (a,b)
1541 # TS-start
1542
1543 # Most functions should have static scope.
1544 # Any that don't must be marked with 'extern', but 'main'
1545 # and 'usage' are exceptions: they're always extern, but
1546 # do not need to be marked.  Symbols matching '__.*' are
1547 # reserved by the compiler, so are automatically excluded below.
1548 _gl_TS_unmarked_extern_functions ?= main usage
1549 _gl_TS_function_match ?= /^(?:$(_gl_TS_extern)) +.*?(\S+) *\(/
1550
1551 # If your project uses a macro like "XTERN", then put
1552 # the following in cfg.mk to override this default:
1553 # export _gl_TS_extern = extern|XTERN
1554 _gl_TS_extern ?= extern
1555
1556 # The second nm|grep checks for file-scope variables with 'extern' scope.
1557 # Without gnulib's progname module, you might put program_name here.
1558 # Symbols matching '__.*' are reserved by the compiler,
1559 # so are automatically excluded below.
1560 _gl_TS_unmarked_extern_vars ?=
1561
1562 # NOTE: the _match variables are perl expressions -- not mere regular
1563 # expressions -- so that you can extend them to match other patterns
1564 # and easily extract matched variable names.
1565 # For example, if your project declares some global variables via
1566 # a macro like this: GLOBAL(type, var_name, initializer), then you
1567 # can override this definition to automatically extract those names:
1568 # export _gl_TS_var_match = \
1569 #   /^(?:$(_gl_TS_extern)) .*?\**(\w+)(\[.*?\])?;/ || /\bGLOBAL\(.*?,\s*(.*?),/
1570 _gl_TS_var_match ?= /^(?:$(_gl_TS_extern)) .*?(\w+)(\[.*?\])?;/
1571
1572 # The names of object files in (or relative to) $(_gl_TS_dir).
1573 _gl_TS_obj_files ?= *.$(OBJEXT)
1574
1575 # Files in which to search for the one-line style extern declarations.
1576 # $(_gl_TS_dir)-relative.
1577 _gl_TS_headers ?= $(noinst_HEADERS)
1578
1579 .PHONY: _gl_tight_scope
1580 _gl_tight_scope: $(bin_PROGRAMS)
1581         t=exceptions-$$$$;                                              \
1582         trap 's=$$?; rm -f $$t; exit $$s' 0;                            \
1583         for sig in 1 2 3 13 15; do                                      \
1584           eval "trap 'v=`expr $$sig + 128`; (exit $$v); exit $$v' $$sig"; \
1585         done;                                                           \
1586         src=`for f in $(SOURCES); do                                    \
1587                test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`;   \
1588         hdr=`for f in $(_gl_TS_headers); do                             \
1589                test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`;   \
1590         ( printf '^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_functions);  \
1591           grep -h -A1 '^extern .*[^;]$$' $$src                          \
1592             | grep -vE '^(extern |--)' | sed 's/ .*//';                 \
1593           perl -lne                                                     \
1594              '$(_gl_TS_function_match) and print "^$$1\$$"' $$hdr;      \
1595         ) | sort -u > $$t;                                              \
1596         nm -e $(_gl_TS_obj_files) | sed -n 's/.* T //p'|grep -Ev -f $$t \
1597           && { echo the above functions should have static scope >&2;   \
1598                exit 1; } || : ;                                         \
1599         ( printf '^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_vars);       \
1600           perl -lne '$(_gl_TS_var_match) and print "^$$1\$$"' $$hdr *.h \
1601         ) | sort -u > $$t;                                              \
1602         nm -e $(_gl_TS_obj_files) | sed -n 's/.* [BCDGRS] //p'          \
1603             | sort -u | grep -Ev -f $$t                                 \
1604           && { echo the above variables should have static scope >&2;   \
1605                exit 1; } || :
1606 # TS-end
1607 endif